// wizView.cpp : implementation of the CWizView class
//

#include "stdafx.h"
#include "wiz.h"

#include "wizDoc.h"
#include "wizView.h"
#include "WizSheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWizView

IMPLEMENT_DYNCREATE(CWizView, CView)

BEGIN_MESSAGE_MAP(CWizView, CView)
	//{{AFX_MSG_MAP(CWizView)
	ON_COMMAND(ID_FILE_WIZARD, OnFileWizard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWizView construction/destruction

CWizView::CWizView()
{
	m_edit = "Default";
	m_check = FALSE;
}

CWizView::~CWizView()
{
}

BOOL CWizView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CWizView drawing

void CWizView::OnDraw(CDC* pDC)
{
	CWizDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	pDC->TextOut(20, 20, m_edit);
	if (m_check)
		pDC->TextOut(20, 50, "TRUE");
	else
		pDC->TextOut(20, 50, "FALSE");
}

/////////////////////////////////////////////////////////////////////////////
// CWizView diagnostics

#ifdef _DEBUG
void CWizView::AssertValid() const
{
	CView::AssertValid();
}

void CWizView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CWizDoc* CWizView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWizDoc)));
	return (CWizDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWizView message handlers

void CWizView::OnFileWizard() 
{
	CWizSheet wizSheet("Sample Wizard", this, 0);
	wizSheet.m_page1.m_edit = m_edit;
	wizSheet.m_page2.m_check = m_check;
	wizSheet.SetWizardMode();
	int result = wizSheet.DoModal();
	if (result == ID_WIZFINISH)
	{
		m_edit = wizSheet.m_page1.m_edit;
		m_check = wizSheet.m_page2.m_check;
		Invalidate();
	}
}
