// CntrItem.cpp : implementation of the CShowStringCntrItem class
//

#include "stdafx.h"
#include "ShowString.h"

#include "ShowStringDoc.h"
#include "ShowStringView.h"
#include "CntrItem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShowStringCntrItem implementation

IMPLEMENT_SERIAL(CShowStringCntrItem, COleClientItem, 0)

CShowStringCntrItem::CShowStringCntrItem(CShowStringDoc* pContainer)
	: COleClientItem(pContainer)
{
     m_rect = CRect(10,10,210,210);     	
}

CShowStringCntrItem::~CShowStringCntrItem()
{
	// TODO: add cleanup code here
	
}

void CShowStringCntrItem::OnChange(OLE_NOTIFICATION nCode, DWORD dwParam)
{
	ASSERT_VALID(this);

	COleClientItem::OnChange(nCode, dwParam);

	// When an item is being edited (either in-place or fully open)
	//  it sends OnChange notifications for changes in the state of the
	//  item or visual appearance of its content.

	// TODO: invalidate the item by calling UpdateAllViews
	//  (with hints appropriate to your application)

	GetDocument()->UpdateAllViews(NULL);
		// for now just update ALL views/no hints
}

BOOL CShowStringCntrItem::OnChangeItemPosition(const CRect& rectPos)
{
	ASSERT_VALID(this);

	if (!COleClientItem::OnChangeItemPosition(rectPos))
		return FALSE;

	m_rect = rectPos;
    GetDocument()->SetModifiedFlag();
    GetDocument()->UpdateAllViews(NULL);

	return TRUE;
}

void CShowStringCntrItem::OnGetItemPosition(CRect& rPosition)
{
	ASSERT_VALID(this);

    rPosition = m_rect;
}

void CShowStringCntrItem::OnActivate()
{
    // Allow only one inplace activate item per frame
    CShowStringView* pView = GetActiveView();
    ASSERT_VALID(pView);
    COleClientItem* pItem = GetDocument()->GetInPlaceActiveItem(pView);
    if (pItem != NULL && pItem != this)
        pItem->Close();
    
    COleClientItem::OnActivate();
}

void CShowStringCntrItem::OnDeactivateUI(BOOL bUndoable)
{
	COleClientItem::OnDeactivateUI(bUndoable);

    // Hide the object if it is not an outside-in object
    DWORD dwMisc = 0;
    m_lpObject->GetMiscStatus(GetDrawAspect(), &dwMisc);
    if (dwMisc & OLEMISC_INSIDEOUT)
        DoVerb(OLEIVERB_HIDE, NULL);
}

void CShowStringCntrItem::Serialize(CArchive& ar)
{
	ASSERT_VALID(this);

	// Call base class first to read in COleClientItem data.
	// Since this sets up the m_pDocument pointer returned from
	//  CShowStringCntrItem::GetDocument, it is a good idea to call
	//  the base class Serialize first.
	COleClientItem::Serialize(ar);

	// now store/retrieve data specific to CShowStringCntrItem
     if (ar.IsStoring())
     {
          ar << m_rect;
     }
     else
     {
          ar >> m_rect;
     }
}

/////////////////////////////////////////////////////////////////////////////
// CShowStringCntrItem diagnostics

#ifdef _DEBUG
void CShowStringCntrItem::AssertValid() const
{
	COleClientItem::AssertValid();
}

void CShowStringCntrItem::Dump(CDumpContext& dc) const
{
	COleClientItem::Dump(dc);
}
#endif

/////////////////////////////////////////////////////////////////////////////
