// ShowStringView.h : interface of the CShowStringView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHOWSTRINGVIEW_H__6744825D_6E26_11D0_B02C_0080C81A3AA2__INCLUDED_)
#define AFX_SHOWSTRINGVIEW_H__6744825D_6E26_11D0_B02C_0080C81A3AA2__INCLUDED_

class CShowStringCntrItem;

class CShowStringView : public CView
{
protected: // create from serialization only
	CShowStringView();
	DECLARE_DYNCREATE(CShowStringView)

// Attributes
public:
	CShowStringDoc* GetDocument();
	CShowStringCntrItem* m_pSelection;
    COleDropTarget m_droptarget;

	CPoint m_dragpoint;
    CSize m_dragsize;
    CSize m_dragoffset;
     
	static CLIPFORMAT m_cfObjectDescriptorFormat;
	BOOL m_OKtodrop;
    BOOL m_FocusRectangleDrawn;

// Operations
public:

     void SetupTracker(CShowStringCntrItem* item, 
		CRectTracker* track);

	CShowStringCntrItem* HitTest(CPoint point);
	void SetSelection(CShowStringCntrItem* item);

	 // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CShowStringView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual void OnDragLeave();
	virtual DROPEFFECT OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual BOOL OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL IsSelected(const CObject* pDocItem) const;// Container support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CShowStringView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CShowStringView)
	afx_msg void OnDestroy();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnInsertObject();
	afx_msg void OnCancelEditCntr();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnEditClear();
	afx_msg void OnUpdateEditClear(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in ShowStringView.cpp
inline CShowStringDoc* CShowStringView::GetDocument()
   { return (CShowStringDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SHOWSTRINGVIEW_H__6744825D_6E26_11D0_B02C_0080C81A3AA2__INCLUDED_)
