// SrvrItem.cpp : implementation of the CShowStringSrvrItem class
//

#include "stdafx.h"
#include "ShowString.h"

#include "ShowStringDoc.h"
#include "SrvrItem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShowStringSrvrItem implementation

IMPLEMENT_DYNAMIC(CShowStringSrvrItem, COleServerItem)

CShowStringSrvrItem::CShowStringSrvrItem(CShowStringDoc* pContainerDoc)
	: COleServerItem(pContainerDoc, TRUE)
{
	// TODO: add one-time construction code here
	//  (eg, adding additional clipboard formats to the item's data source)
}

CShowStringSrvrItem::~CShowStringSrvrItem()
{
	// TODO: add cleanup code here
}

void CShowStringSrvrItem::Serialize(CArchive& ar)
{
	// CShowStringSrvrItem::Serialize will be called by the framework if
	//  the item is copied to the clipboard.  This can happen automatically
	//  through the OLE callback OnGetClipboardData.  A good default for
	//  the embedded item is simply to delegate to the document's Serialize
	//  function.  If you support links, then you will want to serialize
	//  just a portion of the document.

	if (!IsLinkedItem())
	{
		CShowStringDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		pDoc->Serialize(ar);
	}
}

BOOL CShowStringSrvrItem::OnGetExtent(DVASPECT dwDrawAspect, CSize& rSize)
{
	// Most applications, like this one, only handle drawing the content
	//  aspect of the item.  If you wish to support other aspects, such
	//  as DVASPECT_THUMBNAIL (by overriding OnDrawEx), then this
	//  implementation of OnGetExtent should be modified to handle the
	//  additional aspect(s).

	if (dwDrawAspect != DVASPECT_CONTENT)
		return COleServerItem::OnGetExtent(dwDrawAspect, rSize);

	// CShowStringSrvrItem::OnGetExtent is called to get the extent in
	//  HIMETRIC units of the entire item.  The default implementation
	//  here simply returns a hard-coded number of units.

	CShowStringDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: replace this arbitrary size

	rSize = CSize(3000, 3000);   // 3000 x 3000 HIMETRIC units

	return TRUE;
}

BOOL CShowStringSrvrItem::OnDraw(CDC* pDC, CSize& rSize)
{
	// Remove this if you use rSize
	UNREFERENCED_PARAMETER(rSize);

	CShowStringDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

     // TODO: set mapping mode and extent
     //  (The extent is usually the same as the size returned from OnGetExtent)
     pDC->SetMapMode(MM_ANISOTROPIC);
     pDC->SetWindowOrg(0,0);
     pDC->SetWindowExt(3000, 3000);

     COLORREF oldcolor;
     switch (pDoc->GetColor())
     {
     case 0:
          oldcolor = pDC->SetTextColor(RGB(0x80,0x80,0x80)); //gray
          break;
     case 1:
          oldcolor = pDC->SetTextColor(RGB(0xB0,0,0)); // dull red
          break;
     case 2:
          oldcolor = pDC->SetTextColor(RGB(0,0xB0,0)); // dull green
          break;
     }

     int DTflags = 0;
     if (pDoc->GetHorizcenter())
     {
          DTflags |= DT_CENTER;
     }
     if (pDoc->GetVertcenter())
     {
          DTflags |= (DT_VCENTER|DT_SINGLELINE);
     }
     
     CRect rect;
     rect.TopLeft() = pDC->GetWindowOrg();
     rect.BottomRight() = rect.TopLeft() + pDC->GetWindowExt();
     pDC->DrawText(pDoc->GetString(), &rect, DTflags);
     pDC->SetTextColor(oldcolor);

     return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CShowStringSrvrItem diagnostics

#ifdef _DEBUG
void CShowStringSrvrItem::AssertValid() const
{
	COleServerItem::AssertValid();
}

void CShowStringSrvrItem::Dump(CDumpContext& dc) const
{
	COleServerItem::Dump(dc);
}
#endif

/////////////////////////////////////////////////////////////////////////////
