// Win95View.h : interface of the CWin95View class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_WIN95VIEW_H__5124FEAE_7F4E_11D0_B02C_0080C81A3AA2__INCLUDED_)
#define AFX_WIN95VIEW_H__5124FEAE_7F4E_11D0_B02C_0080C81A3AA2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CWin95View : public CView
{
protected: // create from serialization only
	CWin95View();
	DECLARE_DYNCREATE(CWin95View)

// Attributes
public:
	CWin95Doc* GetDocument();

protected:
    CProgressCtrl m_progressBar;
    CSliderCtrl m_trackbar;
    BOOL m_timer;
    CSpinButtonCtrl m_upDown;
    CEdit m_buddyEdit;
    CListCtrl m_listView;
    CImageList m_smallImageList;
    CImageList m_largeImageList;
    CButton m_smallButton;
    CButton m_largeButton;
    CButton m_listButton;
    CButton m_reportButton;
    CTreeCtrl m_treeView;
    CImageList m_treeImageList;
    CRichEditCtrl m_richEdit;
    CButton m_boldButton;
    CButton m_leftButton;
    CButton m_centerButton;
    CButton m_rightButton;


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWin95View)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CWin95View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void CreateProgressBar();
    void CreateTrackbar();
	void CreateUpDownCtrl();
	void CreateListView();
	void CreateTreeView();
	void CreateRichEdit();

// Generated message map functions
	//{{AFX_MSG(CWin95View)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	afx_msg void OnSmall();
	afx_msg void OnLarge();
	afx_msg void OnList();
	afx_msg void OnReport();
	afx_msg void OnULine();
	afx_msg void OnLeft();
	afx_msg void OnCenter();
	afx_msg void OnRight();

	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in Win95View.cpp
inline CWin95Doc* CWin95View::GetDocument()
   { return (CWin95Doc*)m_pDocument; }
#endif


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WIN95VIEW_H__5124FEAE_7F4E_11D0_B02C_0080C81A3AA2__INCLUDED_)
