// ArrayView.cpp : implementation of the CArrayView class
//

#include "stdafx.h"
#include "Array.h"

#include "ArrayDoc.h"
#include "ArrayView.h"
#include "ArrayAddDlg.h"
#include "ArrayRemoveDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CArrayView

IMPLEMENT_DYNCREATE(CArrayView, CView)

BEGIN_MESSAGE_MAP(CArrayView, CView)
	//{{AFX_MSG_MAP(CArrayView)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArrayView construction/destruction

CArrayView::CArrayView()
{
	array.SetSize(10, 5);
}

CArrayView::~CArrayView()
{
}

BOOL CArrayView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CArrayView drawing

void CArrayView::OnDraw(CDC* pDC)
{
    CArrayDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);
    
    // Get the current font's height.
    TEXTMETRIC textMetric;
    pDC->GetTextMetrics(&textMetric);
    int fontHeight = textMetric.tmHeight;
    // Get the size of the array.
    int count = array.GetSize();
    int displayPos = 10;
    // Display the array data.
    for (int x=0; x<count; ++x)
    {
        UINT value = array.GetAt(x);
        char s[81];
        wsprintf(s, "Element %d contains the value %u.", x, value);
        pDC->TextOut(10, displayPos, s);
        displayPos += fontHeight;
    }
}

/////////////////////////////////////////////////////////////////////////////
// CArrayView diagnostics

#ifdef _DEBUG
void CArrayView::AssertValid() const
{
	CView::AssertValid();
}

void CArrayView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CArrayDoc* CArrayView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CArrayDoc)));
	return (CArrayDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CArrayView message handlers

void CArrayView::OnLButtonDown(UINT nFlags, CPoint point) 
{
    ArrayAddDlg dialog(this);
    dialog.m_index = 0;
    dialog.m_value = 0;
    dialog.m_radio = 0;
    int result = dialog.DoModal();
    if (result == IDOK)
    {
        if (dialog.m_radio == 0)
            array.SetAtGrow(dialog.m_index, dialog.m_value);
        else if (dialog.m_radio == 1)
            array.InsertAt(dialog.m_index, dialog.m_value, 1);
        else
            array.Add(dialog.m_value);
        Invalidate();
    }
    CView::OnLButtonDown(nFlags, point);
}

void CArrayView::OnRButtonDown(UINT nFlags, CPoint point) 
{
    ArrayRemoveDlg dialog(this);
    dialog.m_remove = 0;
    dialog.m_removeAll = FALSE;
    int result = dialog.DoModal();
    if (result == IDOK)
    {
        if (dialog.m_removeAll)
            array.RemoveAll();
        else
            array.RemoveAt(dialog.m_remove);
        Invalidate();
    }
    
    CView::OnRButtonDown(nFlags, point);
}
