// DierollDataPathProperty.cpp : implementation file
//

#include "stdafx.h"
#include "Dieroll.h"
#include "DierollDataPathProperty.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDierollDataPathProperty

CDierollDataPathProperty::CDierollDataPathProperty()
{
	hBitmap = NULL;
	BitmapDataLoaded = FALSE;
}

CDierollDataPathProperty::~CDierollDataPathProperty()
{
	if (hBitmap)
	{
		DeleteObject(hBitmap);
	}
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CDierollDataPathProperty, CCachedDataPathProperty)
	//{{AFX_MSG_MAP(CDierollDataPathProperty)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CDierollDataPathProperty member functions

BOOL CDierollDataPathProperty::ReadBitmap(CFile &file)
{
	BITMAPFILEHEADER bmfh;

	long file_length = file.SeekToEnd();
	file.SeekToBegin();

	/* Retrieve the BITMAPFILEHEADER structure. */ 
 	if (file.Read(&bmfh, sizeof(BITMAPFILEHEADER)) != sizeof(BITMAPFILEHEADER))
	{
		// return FALSE to indicate an error occured
		return FALSE;
	}
 
	/* Retrieve the BITMAPINFOHEADER structure. */ 
	if (file.Read(&bmih, sizeof(BITMAPINFOHEADER)) != sizeof(BITMAPINFOHEADER))
	{
		// return FALSE to indicate an error occured
		return FALSE;
	}
 
	long colour_size = file_length - bmih.biSizeImage -
		    sizeof(BITMAPFILEHEADER) - bmih.biSize;

	/* Allocate memory for the BITMAPINFO structure. */ 
	//  shifting bmih.biBitCound does not work for 24 bit colour
//	hmem1 = GlobalAlloc(GHND, sizeof(BITMAPINFOHEADER) + 
//		((1<<bmih.biBitCount) * sizeof(RGBQUAD))); 
	hmem1 = GlobalAlloc(GHND, sizeof(BITMAPINFOHEADER) + colour_size); 
 
	/* Lock it */
	lpbmi = (BITMAPINFO *)GlobalLock(hmem1); 
 
	/* 
	 * Load BITMAPINFOHEADER into the BITMAPINFO 
	 * structure. 
	 */ 
 
	lpbmi->bmiHeader.biSize = bmih.biSize; 
	lpbmi->bmiHeader.biWidth = bmih.biWidth; 
	lpbmi->bmiHeader.biHeight = bmih.biHeight; 
	lpbmi->bmiHeader.biPlanes = bmih.biPlanes; 
	lpbmi->bmiHeader.biBitCount = bmih.biBitCount; 
	lpbmi->bmiHeader.biCompression = bmih.biCompression; 
	lpbmi->bmiHeader.biSizeImage = bmih.biSizeImage; 
	lpbmi->bmiHeader.biXPelsPerMeter = bmih.biXPelsPerMeter; 
	lpbmi->bmiHeader.biYPelsPerMeter = bmih.biYPelsPerMeter; 
	lpbmi->bmiHeader.biClrUsed = bmih.biClrUsed; 
	lpbmi->bmiHeader.biClrImportant = bmih.biClrImportant; 
 
	/* 
	 * Retrieve the color table. 
	 * 1 << bmih.biBitCount == 2 ^ bmih.biBitCount 
	 */ 
	/*
	 *  for 24 bits this does not work - see new algorithm 
	 *  below
	 */
 
//	if (file.Read(lpbmi->bmiColors, 
//			((1<<bmih.biBitCount) * sizeof(RGBQUAD))) != ((1<<bmih.biBitCount) * sizeof(RGBQUAD)) )
//	{
//		// return FALSE to indicate an error occured
//		GlobalUnlock(hmem1); 
//		GlobalFree(hmem1);
//		return FALSE;
//	}
 
	/*
	 *   The colour array size is calculated by taking the size of
	 *   the file and subtracting off the size of the image and the
	 *   size of the headers
	 *       still do not like this as it can be wrong with a 
	 *       damaged file. Also it is hard to say if it will
	 *       always work. But it does work for more cases then
	 *       the old code. 
	 */

	if (colour_size > 0)
	{
		if (file.Read(lpbmi->bmiColors, colour_size) != (unsigned long)colour_size )
		{
			// return FALSE to indicate an error occured
			GlobalUnlock(hmem1); 
			GlobalFree(hmem1);
			return FALSE;
		}
	}

	/* 
	 * Allocate memory for the required number of 
	 * bytes. 
	 */ 
 
	hmem2 = GlobalAlloc(GHND, (bmfh.bfSize - bmfh.bfOffBits)); 
 
	lpvBits = (char *)GlobalLock(hmem2); 
 
	/* Retrieve the bitmap data. */ 
 
	if (file.Read(lpvBits, (bmfh.bfSize - bmfh.bfOffBits) ) != (bmfh.bfSize - bmfh.bfOffBits))
	{
		// return FALSE to indicate an error occured
		GlobalUnlock(hmem1); 
		GlobalFree(hmem1);
		GlobalUnlock(hmem2); 
		GlobalFree(hmem2);
		return FALSE;
	}
 
	return TRUE;
}
void CDierollDataPathProperty::OnDataAvailable(DWORD dwSize, DWORD grfBSCF)
{
	CCachedDataPathProperty::OnDataAvailable(dwSize, grfBSCF);

	if (grfBSCF & BSCF_LASTDATANOTIFICATION)
	{
		m_Cache.SeekToBegin();
		if (ReadBitmap(m_Cache))
		{
			BitmapDataLoaded = TRUE;
			// safe because this control has only one property:
			GetControl()->InternalSetReadyState(READYSTATE_COMPLETE);
			GetControl()->InvalidateControl();
		}
	}

	//Notice the complete absence of idiot-proofing.
	//If the web page has a bad URL or if the URL
	//isn't a bitmap (say it's a GIF instead) then
	//ReadBitmap() will never return TRUE, the control
	//will never be READYSTATE_COMPLETE, and the web page
	//user will have to guess what's wrong or go through
	//in the debugger.
}

void CDierollDataPathProperty::OnProgress( ULONG ulProgress, ULONG ulProgressMax, ULONG ulStatusCode, LPCTSTR szStatusText )
{
	BINDSTATUS status = (BINDSTATUS)ulStatusCode;
	if (status == BINDSTATUS_ENDDOWNLOADDATA)
	{
		// Could have put code here or just use as a place to 
		// breakpoint
	}
}



CBitmap* CDierollDataPathProperty::GetBitmap(HDC hdc)
{
	if (BitmapDataLoaded)
	{
		/* 
		 * Create a bitmap from the data stored in the 
		 * .BMP file. 
		 */ 
 
		hBitmap = CreateDIBitmap(hdc, &bmih, CBM_INIT, lpvBits, 
						 lpbmi, DIB_RGB_COLORS); 

		GlobalUnlock(hmem1);
		GlobalUnlock(hmem2);

		if (hBitmap)
		{
			return CBitmap::FromHandle(hBitmap); 
		}
		else
		{
			GlobalFree(hmem1);
			GlobalFree(hmem2);
			BitmapDataLoaded = FALSE;
			return NULL;
		}
	}
	else
	{
		return NULL;
	}
}
