// DieRollPPG.h : Declaration of the CDieRollPPG

#ifndef __DIEROLLPPG_H_
#define __DIEROLLPPG_H_

#include "resource.h"       // main symbols
#include "DieRollControl.h"

EXTERN_C const CLSID CLSID_DieRollPPG;

/////////////////////////////////////////////////////////////////////////////
// CDieRollPPG
class ATL_NO_VTABLE CDieRollPPG :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDieRollPPG, &CLSID_DieRollPPG>,
	public IPropertyPageImpl<CDieRollPPG>,
	public CDialogImpl<CDieRollPPG>
{
public:
	CDieRollPPG() 
	{
		m_dwTitleID = IDS_TITLEDieRollPPG;
		m_dwHelpFileID = IDS_HELPFILEDieRollPPG;
		m_dwDocStringID = IDS_DOCSTRINGDieRollPPG;
	}

	enum {IDD = IDD_DIEROLLPPG};

DECLARE_REGISTRY_RESOURCEID(IDR_DIEROLLPPG)

BEGIN_COM_MAP(CDieRollPPG) 
	COM_INTERFACE_ENTRY_IMPL(IPropertyPage)
END_COM_MAP()

BEGIN_MSG_MAP(CDieRollPPG)
    MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
    COMMAND_HANDLER(IDC_DOTS, BN_CLICKED, OnDotsChanged)
    COMMAND_HANDLER(IDC_IMAGE, EN_CHANGE, OnImageChanged)
	CHAIN_MSG_MAP(IPropertyPageImpl<CDieRollPPG>)
END_MSG_MAP()

    LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, 
                         BOOL & bHandled)
    {
        USES_CONVERSION;

        CComQIPtr<IDieRoll, &IID_IDieRoll> pDieRoll(m_ppUnk[0]);

        BOOL dots;
        pDieRoll->get_Dots(&dots);
        ::SendDlgItemMessage(m_hWnd, IDC_DOTS, BM_SETCHECK, dots, 0L); 

        BSTR image;
        pDieRoll->get_Image(&image);
        LPTSTR image_URL = W2T(image);
        SetDlgItemText(IDC_IMAGE, image_URL);

        return TRUE;
    }

    LRESULT OnDotsChanged(WORD wNotify, WORD wID, HWND hWnd, BOOL& bHandled)
    {
        SetDirty(TRUE);
        return FALSE;
    }

    LRESULT OnImageChanged(WORD wNotify, WORD wID, HWND hWnd, BOOL& bHandled)
    {
        SetDirty(TRUE);
        return FALSE;
    }


    STDMETHOD(Apply)(void)
    {
        USES_CONVERSION;
        BSTR image = NULL;
        GetDlgItemText(IDC_IMAGE, image);

        BOOL dots = (BOOL)::SendDlgItemMessage(m_hWnd, IDC_DOTS, 
                BM_GETCHECK, 0, 0L); 

        ATLTRACE(_T("CDieRollPPG::Apply\n"));
        for (UINT i = 0; i < m_nObjects; i++)
        {
            CComQIPtr<IDieRoll, &IID_IDieRoll> pDieRoll(m_ppUnk[i]);

            if FAILED(pDieRoll->put_Dots(dots))
            {
                CComPtr<IErrorInfo> pError;
                CComBSTR            strError;
                GetErrorInfo(0, &pError);
                pError->GetDescription(&strError);
                MessageBox(OLE2T(strError), _T("Error"), MB_ICONEXCLAMATION);
                return E_FAIL;
            }

            if FAILED(pDieRoll->put_Image(image))
            {
                CComPtr<IErrorInfo> pError;
                CComBSTR            strError;
                GetErrorInfo(0, &pError);
                pError->GetDescription(&strError);
                MessageBox(OLE2T(strError), _T("Error"), MB_ICONEXCLAMATION);
                return E_FAIL;
            }
        }
        m_bDirty = FALSE;
        return S_OK;
    }
};

#endif //__DIEROLLPPG_H_
