// Win95View.cpp : implementation of the CWin95View class
//

#include "stdafx.h"
#include "Win95.h"

#include "Win95Doc.h"
#include "Win95View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWin95View

IMPLEMENT_DYNCREATE(CWin95View, CView)

BEGIN_MESSAGE_MAP(CWin95View, CView)
	//{{AFX_MSG_MAP(CWin95View)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_WM_TIMER()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
	ON_COMMAND(IDC_LISTVIEW_SMALL, OnSmall)
	ON_COMMAND(IDC_LISTVIEW_LARGE, OnLarge)
	ON_COMMAND(IDC_LISTVIEW_LIST, OnList)
	ON_COMMAND(IDC_LISTVIEW_REPORT, OnReport)
	ON_COMMAND(IDC_RICHEDIT_ULINE, OnULine)
	ON_COMMAND(IDC_RICHEDIT_LEFT, OnLeft)
	ON_COMMAND(IDC_RICHEDIT_CENTER, OnCenter)
	ON_COMMAND(IDC_RICHEDIT_RIGHT, OnRight)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWin95View construction/destruction

CWin95View::CWin95View()
{
	// TODO: add construction code here

}

CWin95View::~CWin95View()
{
}

BOOL CWin95View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CWin95View drawing

void CWin95View::OnDraw(CDC* pDC)
{
	CWin95Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDC->TextOut(20, 22, "Progress Bar Control");
	pDC->TextOut(270, 22, "Trackbar Control:");
	pDC->TextOut(20, 102, "Up-Down Control");
	pDC->TextOut(160, 102, "List View Control");
	pDC->TextOut(20, 240, "Tree View Control");
	pDC->TextOut(180, 240, "Rich Edit Control");
}


/////////////////////////////////////////////////////////////////////////////
// CWin95View diagnostics

#ifdef _DEBUG
void CWin95View::AssertValid() const
{
	CView::AssertValid();
}

void CWin95View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CWin95Doc* CWin95View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWin95Doc)));
	return (CWin95Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWin95View message handlers

int CWin95View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	CreateProgressBar();	
	CreateTrackbar();
	CreateUpDownCtrl();
	CreateListView();
	CreateTreeView();
	CreateRichEdit();

	return 0;
}

void CWin95View::CreateProgressBar()
{
	m_progressBar.Create(WS_CHILD | WS_VISIBLE | WS_BORDER,
	    CRect(20, 40, 250, 80), this, IDC_PROGRESSBAR);

	m_progressBar.SetRange(1, 100);
	m_progressBar.SetStep(10);
	m_progressBar.SetPos(50);
	m_timer = FALSE;

}

void CWin95View::CreateTrackbar()
{
	m_trackbar.Create(WS_CHILD | WS_VISIBLE | WS_BORDER |
		TBS_AUTOTICKS | TBS_BOTH | TBS_HORZ,
		CRect(270, 40, 450, 80), this, IDC_TRACKBAR);
	m_trackbar.SetRange(0, 100, TRUE);
	m_trackbar.SetTicFreq(10);
	m_trackbar.SetLineSize(1);
	m_trackbar.SetPageSize(10);
}

void CWin95View::CreateUpDownCtrl()
{
	m_buddyEdit.Create(WS_CHILD | WS_VISIBLE | WS_BORDER,
		CRect(50, 120, 110, 160), this, IDC_BUDDYEDIT);
	m_upDown.Create(WS_CHILD | WS_VISIBLE | WS_BORDER |
		UDS_ALIGNRIGHT | UDS_SETBUDDYINT | UDS_ARROWKEYS,
		CRect(0, 0, 0, 0), this, IDC_UPDOWN);
	m_upDown.SetBuddy(&m_buddyEdit);
	m_upDown.SetRange(1, 100);
	m_upDown.SetPos(50);
}

void CWin95View::CreateListView()
{
	// Create the Image List controls.
    m_smallImageList.Create(16, 16, FALSE, 1, 0);
	m_largeImageList.Create(32, 32, FALSE, 1, 0);
	HICON hIcon = ::LoadIcon (AfxGetResourceHandle(),
		MAKEINTRESOURCE(IDI_ICON1));
    m_smallImageList.Add(hIcon);
	hIcon = ::LoadIcon (AfxGetResourceHandle(),
		MAKEINTRESOURCE(IDI_ICON2));
    m_largeImageList.Add(hIcon);

	// Create the List View control.
	m_listView.Create(WS_VISIBLE | WS_CHILD | WS_BORDER |
		LVS_REPORT | LVS_NOSORTHEADER | LVS_EDITLABELS,
		CRect(160, 120, 394, 220), this, IDC_LISTVIEW);
	m_listView.SetImageList(&m_smallImageList, LVSIL_SMALL);
	m_listView.SetImageList(&m_largeImageList, LVSIL_NORMAL);

	// Create the columns.
	LV_COLUMN lvColumn;
	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvColumn.fmt = LVCFMT_CENTER;
	lvColumn.cx = 75;

	lvColumn.iSubItem = 0;
	lvColumn.pszText = "Column 0";
	m_listView.InsertColumn(0, &lvColumn);
	lvColumn.iSubItem = 1;
	lvColumn.pszText = "Column 1";
	m_listView.InsertColumn(1, &lvColumn);
	lvColumn.iSubItem = 2;
	lvColumn.pszText = "Column 2";
	m_listView.InsertColumn(1, &lvColumn);

	// Create the items.
	LV_ITEM lvItem;
	lvItem.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE;
	lvItem.state = 0;      
	lvItem.stateMask = 0;  
	lvItem.iImage = 0;

	lvItem.iItem = 0;
	lvItem.iSubItem = 0;
	lvItem.pszText = "Item 0";
    m_listView.InsertItem(&lvItem);
	m_listView.SetItemText(0, 1, "Sub Item 0.1");
	m_listView.SetItemText(0, 2, "Sub Item 0.2");

	lvItem.iItem = 1;
	lvItem.iSubItem = 0;
	lvItem.pszText = "Item 1";
    m_listView.InsertItem(&lvItem);
	m_listView.SetItemText(1, 1, "Sub Item 1.1");
	m_listView.SetItemText(1, 2, "Sub Item 1.2");

	lvItem.iItem = 2;
	lvItem.iSubItem = 0;
	lvItem.pszText = "Item 2";
    m_listView.InsertItem(&lvItem);
	m_listView.SetItemText(2, 1, "Sub Item 2.1");
	m_listView.SetItemText(2, 2, "Sub Item 2.2");

	// Create the view-control buttons.
	m_smallButton.Create("Small", WS_VISIBLE | WS_CHILD | WS_BORDER,
		CRect(400, 120, 450, 140), this, IDC_LISTVIEW_SMALL);
	m_largeButton.Create("Large", WS_VISIBLE | WS_CHILD | WS_BORDER,
		CRect(400, 145, 450, 165), this, IDC_LISTVIEW_LARGE);
	m_listButton.Create("List", WS_VISIBLE | WS_CHILD | WS_BORDER,
		CRect(400, 170, 450, 190), this, IDC_LISTVIEW_LIST);
	m_reportButton.Create("Report", WS_VISIBLE | WS_CHILD | WS_BORDER,
		CRect(400, 195, 450, 215), this, IDC_LISTVIEW_REPORT);
}

void CWin95View::CreateTreeView()
{
	// Create the Image List.
	m_treeImageList.Create(13, 13, FALSE, 3, 0);
	HICON hIcon = ::LoadIcon(AfxGetResourceHandle(),
		MAKEINTRESOURCE(IDI_ICON3));
	m_treeImageList.Add(hIcon);
	hIcon = ::LoadIcon(AfxGetResourceHandle(),
		MAKEINTRESOURCE(IDI_ICON4));
	m_treeImageList.Add(hIcon);
	hIcon = ::LoadIcon(AfxGetResourceHandle(),
		MAKEINTRESOURCE(IDI_ICON5));
	m_treeImageList.Add(hIcon);

	// Create the Tree View control.
	m_treeView.Create(WS_VISIBLE | WS_CHILD | WS_BORDER |
		TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS |
		TVS_EDITLABELS, CRect(20, 260, 160, 360), this, 
		IDC_TREEVIEW);
	m_treeView.SetImageList(&m_treeImageList, TVSIL_NORMAL);

	// Create the root item.
	TV_ITEM tvItem;
	tvItem.mask =
		TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
	tvItem.pszText = "Root";
	tvItem.cchTextMax = 4;
	tvItem.iImage = 0;
	tvItem.iSelectedImage = 0;
	TV_INSERTSTRUCT tvInsert;
	tvInsert.hParent = TVI_ROOT;
	tvInsert.hInsertAfter = TVI_FIRST;
	tvInsert.item = tvItem;
	HTREEITEM hRoot = m_treeView.InsertItem(&tvInsert);

	// Create the first child item.
	tvItem.pszText = "Child Item 1";
	tvItem.cchTextMax = 12;
	tvItem.iImage = 1;
	tvItem.iSelectedImage = 1;
	tvInsert.hParent = hRoot;
	tvInsert.hInsertAfter = TVI_FIRST;
	tvInsert.item = tvItem;
	HTREEITEM hChildItem = m_treeView.InsertItem(&tvInsert);

	// Create a child of the first child item.
	tvItem.pszText = "Child Item 2";
	tvItem.cchTextMax = 12;
	tvItem.iImage = 2;
	tvItem.iSelectedImage = 2;
	tvInsert.hParent = hChildItem;
	tvInsert.hInsertAfter = TVI_FIRST;
	tvInsert.item = tvItem;
	m_treeView.InsertItem(&tvInsert);

	// Create another child of the root item.
	tvItem.pszText = "Child Item 3";
	tvItem.cchTextMax = 12;
	tvItem.iImage = 1;
	tvItem.iSelectedImage = 1;
	tvInsert.hParent = hRoot;
	tvInsert.hInsertAfter = TVI_LAST;
	tvInsert.item = tvItem;
	m_treeView.InsertItem(&tvInsert);
}

void CWin95View::CreateRichEdit()
{
	m_richEdit.Create(WS_CHILD | WS_VISIBLE | WS_BORDER |
		ES_AUTOVSCROLL | ES_MULTILINE,
		CRect(180, 260, 393, 360), this, IDC_RICHEDIT);

	m_boldButton.Create("ULine", WS_VISIBLE | WS_CHILD | WS_BORDER,
		CRect(400, 260, 450, 280), this, IDC_RICHEDIT_ULINE);
	m_leftButton.Create("Left", WS_VISIBLE | WS_CHILD | WS_BORDER,
		CRect(400, 285, 450, 305), this, IDC_RICHEDIT_LEFT);
	m_centerButton.Create("Center", WS_VISIBLE | WS_CHILD | WS_BORDER,
		CRect(400, 310, 450, 330), this, IDC_RICHEDIT_CENTER);
	m_rightButton.Create("Right", WS_VISIBLE | WS_CHILD | WS_BORDER,
		CRect(400, 335, 450, 355), this, IDC_RICHEDIT_RIGHT);
}


void CWin95View::OnDestroy() 
{
	CView::OnDestroy();
	
	KillTimer(1);
	
}

void CWin95View::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_timer)
	{
		KillTimer(1);
		m_timer = FALSE;
	}
	else
	{
        SetTimer(1, 500, NULL);
		m_timer = TRUE;
	}

	CView::OnLButtonDown(nFlags, point);
}

void CWin95View::OnTimer(UINT nIDEvent) 
{
	m_progressBar.StepIt();
	CView::OnTimer(nIDEvent);
}


void CWin95View::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CSliderCtrl* slider = (CSliderCtrl*)pScrollBar;
	int position = slider->GetPos();
    char s[10];
	wsprintf(s, "%d   ", position);
	CClientDC clientDC(this);
	clientDC.TextOut(390, 22, s);

	CView::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CWin95View::OnSmall() 
{
	SetWindowLong(m_listView.m_hWnd, GWL_STYLE,
		WS_VISIBLE | WS_CHILD | WS_BORDER |
		LVS_SMALLICON | LVS_EDITLABELS);
}

void CWin95View::OnLarge() 
{
	SetWindowLong(m_listView.m_hWnd, GWL_STYLE,
		WS_VISIBLE | WS_CHILD | WS_BORDER |
		LVS_ICON | LVS_EDITLABELS);
}

void CWin95View::OnList() 
{
	SetWindowLong(m_listView.m_hWnd, GWL_STYLE,
		WS_VISIBLE | WS_CHILD | WS_BORDER |
		LVS_LIST | LVS_EDITLABELS);
}

void CWin95View::OnReport() 
{
	SetWindowLong(m_listView.m_hWnd, GWL_STYLE,
		WS_VISIBLE | WS_CHILD | WS_BORDER |
		LVS_REPORT | LVS_EDITLABELS);
}

void CWin95View::OnULine() 
{
	CHARFORMAT charFormat;
	charFormat.cbSize = sizeof(CHARFORMAT);
	charFormat.dwMask = CFM_UNDERLINE;
	m_richEdit.GetSelectionCharFormat(charFormat);

	if (charFormat.dwEffects & CFM_UNDERLINE)
		charFormat.dwEffects = 0;
	else
	    charFormat.dwEffects = CFE_UNDERLINE;

	m_richEdit.SetSelectionCharFormat(charFormat);
	m_richEdit.SetFocus();
}

void CWin95View::OnLeft() 
{
	PARAFORMAT paraFormat;
	paraFormat.cbSize = sizeof(PARAFORMAT);
	paraFormat.dwMask = PFM_ALIGNMENT;
	paraFormat.wAlignment = PFA_LEFT;
	m_richEdit.SetParaFormat(paraFormat);
	m_richEdit.SetFocus();
}

void CWin95View::OnCenter() 
{
	PARAFORMAT paraFormat;
	paraFormat.cbSize = sizeof(PARAFORMAT);
	paraFormat.dwMask = PFM_ALIGNMENT;
	paraFormat.wAlignment = PFA_CENTER;
	m_richEdit.SetParaFormat(paraFormat);
	m_richEdit.SetFocus();
}

void CWin95View::OnRight() 
{
	PARAFORMAT paraFormat;
	paraFormat.cbSize = sizeof(PARAFORMAT);
	paraFormat.dwMask = PFM_ALIGNMENT;
	paraFormat.wAlignment = PFA_RIGHT;
	m_richEdit.SetParaFormat(paraFormat);
	m_richEdit.SetFocus();
}

BOOL CWin95View::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	LV_DISPINFO* lv_dispInfo = (LV_DISPINFO*) lParam;

	if (lv_dispInfo->hdr.code == LVN_BEGINLABELEDIT)
	{
		CEdit* pEdit = m_listView.GetEditControl();
		// Manipulate edit control here.
	}
	else if (lv_dispInfo->hdr.code == LVN_ENDLABELEDIT)
	{
		if ((lv_dispInfo->item.pszText != NULL) &&
			(lv_dispInfo->item.iItem != -1))
		{
		    m_listView.SetItemText(lv_dispInfo->item.iItem,
			    0, lv_dispInfo->item.pszText);
		}
	}

	TV_DISPINFO* tv_dispInfo = (TV_DISPINFO*) lParam;

	if (tv_dispInfo->hdr.code == TVN_BEGINLABELEDIT)
	{
		CEdit* pEdit = m_treeView.GetEditControl();
		// Manipulate edit control here.
	}
	else if (tv_dispInfo->hdr.code == TVN_ENDLABELEDIT)
	{
		if (tv_dispInfo->item.pszText != NULL)
		{
		    m_treeView.SetItemText(tv_dispInfo->item.hItem,
			    tv_dispInfo->item.pszText);
		}
    }

	return CView::OnNotify(wParam, lParam, pResult);
}


