// Paint1View.cpp : implementation of the CPaint1View class
//

#include "stdafx.h"
#include "Paint1.h"

#include "Paint1Doc.h"
#include "Paint1View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPaint1View

IMPLEMENT_DYNCREATE(CPaint1View, CView)

BEGIN_MESSAGE_MAP(CPaint1View, CView)
	//{{AFX_MSG_MAP(CPaint1View)
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPaint1View construction/destruction

CPaint1View::CPaint1View()
{
	// TODO: add construction code here
	m_Display = Fonts;

}

CPaint1View::~CPaint1View()
{
}

BOOL CPaint1View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPaint1View drawing

void CPaint1View::OnDraw(CDC* pDC)
{
	CPaint1Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	switch (m_Display)
	{
		case Fonts:
			ShowFonts(pDC);
			break;
		case Pens:
			ShowPens(pDC);
			break;
		case Brushes:
			ShowBrushes(pDC);
			break;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPaint1View diagnostics

#ifdef _DEBUG
void CPaint1View::AssertValid() const
{
	CView::AssertValid();
}

void CPaint1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPaint1Doc* CPaint1View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPaint1Doc)));
	return (CPaint1Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPaint1View message handlers

void CPaint1View::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_Display == Fonts)
		m_Display = Pens;
	else if (m_Display == Pens)
		m_Display = Brushes;
	else
		m_Display = Fonts;

	Invalidate();
	
	CView::OnLButtonDown(nFlags, point);
}

void CPaint1View::ShowFonts(CDC * pDC)
{
	// Initialize a LOGFONT structure for the fonts.
	LOGFONT logFont;
    logFont.lfHeight = 8;
    logFont.lfWidth = 0;
    logFont.lfEscapement = 0;
    logFont.lfOrientation = 0;
    logFont.lfWeight = FW_NORMAL;
    logFont.lfItalic = 0;
    logFont.lfUnderline = 0;
    logFont.lfStrikeOut = 0;
    logFont.lfCharSet = ANSI_CHARSET;
    logFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
    logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    logFont.lfQuality = PROOF_QUALITY;
    logFont.lfPitchAndFamily = VARIABLE_PITCH | FF_ROMAN;
	strcpy(logFont.lfFaceName, "Times New Roman");

	// Initialize the position of text in the window.
	UINT position = 0;

	// Create and display eight example fonts.
	for (UINT x=0; x<8; ++x)
	{
		// Set the new font's height.
        logFont.lfHeight = 16 + (x * 8);

		// Create a new font and select it into the DC.
	    CFont font;
	    font.CreateFontIndirect(&logFont);
	    CFont* oldFont = pDC->SelectObject(&font);

		// Print text with the new font.
		position += logFont.lfHeight;
	    pDC->TextOut(20, position, "A sample font.");

		// Restore the old font to the DC.
	    pDC->SelectObject(oldFont);
	}
}

void CPaint1View::ShowPens(CDC * pDC)
{
	// Initialize the line position.
	UINT position = 10;

	// Draw sixteen lines in the window.
	for (UINT x=0; x<16; ++x)
	{
		// Create a new pen and select it into the DC.
		CPen pen(PS_SOLID, x*2+1, RGB(0, 0, 255));
		CPen* oldPen = pDC->SelectObject(&pen);

		// Draw a line with the new pen.
		position +=  x * 2 + 10;
		pDC->MoveTo(20, position);
		pDC->LineTo(400, position);

		// Restore the old pen to the DC.
		pDC->SelectObject(oldPen);
	}
}

void CPaint1View::ShowBrushes(CDC * pDC)
{
	// Initialize the rectangle position.
	UINT position = 0;

	// Select pen to use for rectangle borders
	CPen pen(PS_SOLID, 5, RGB(255, 0, 0));
	CPen* oldPen = pDC->SelectObject(&pen);

	// Draw seven rectangles.
	for (UINT x=0; x<7; ++x)
	{
		CBrush* brush;

		// Create a solid or hatched brush.
		if (x == 6)
			brush = new CBrush(RGB(0,255,0));
		else
		    brush = new CBrush(x, RGB(0,160,0));

		// Select the new brush into the DC.
		CBrush* oldBrush = pDC->SelectObject(brush);

		// Draw the rectangle.
		position += 50;
		pDC->Rectangle(20, position, 400, position + 40);

		// Restore the DC and delete the brush.
		pDC->SelectObject(oldBrush);
		delete brush;
	}

	// Restore the old pen to the DC.
	pDC->SelectObject(oldPen);
}
