// scrollView.cpp : implementation of the CMyScrollView class
//

#include "stdafx.h"
#include "scroll.h"

#include "scrollDoc.h"
#include "scrollView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyScrollView

IMPLEMENT_DYNCREATE(CMyScrollView, CScrollView)

BEGIN_MESSAGE_MAP(CMyScrollView, CScrollView)
	//{{AFX_MSG_MAP(CMyScrollView)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyScrollView construction/destruction

CMyScrollView::CMyScrollView()
{
	// TODO: add construction code here

}

CMyScrollView::~CMyScrollView()
{
}

BOOL CMyScrollView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMyScrollView drawing

void CMyScrollView::OnDraw(CDC* pDC)
{
	CScrollDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// get the number of lines from the document
	int numLines = pDoc->m_NumLines;

	// Initialize a LOGFONT structure for the fonts.
	LOGFONT logFont;
    logFont.lfHeight = 24;
    logFont.lfWidth = 0;
    logFont.lfEscapement = 0;
    logFont.lfOrientation = 0;
    logFont.lfWeight = FW_NORMAL;
    logFont.lfItalic = 0;
    logFont.lfUnderline = 0;
    logFont.lfStrikeOut = 0;
    logFont.lfCharSet = ANSI_CHARSET;
    logFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
    logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    logFont.lfQuality = PROOF_QUALITY;
    logFont.lfPitchAndFamily = VARIABLE_PITCH | FF_ROMAN;
	strcpy(logFont.lfFaceName, "Times New Roman");

	// Create a new font and select it into the DC.
    CFont* font = new CFont();
	font->CreateFontIndirect(&logFont);
	CFont* oldFont = pDC->SelectObject(font);

	// Initialize the position of text in the window.
	UINT position = 0;

	// Create and display eight example lines.
	for (int x=0; x<numLines; ++x)
	{
		// Create the string to display.
		char s[25];
		wsprintf(s, "This is line #%d", x+1);

		// Print text with the new font.
		pDC->TextOut(20, position, s);
		position += logFont.lfHeight;
	}

	// Calculate the document size.
	CSize docSize(100, numLines*logFont.lfHeight);

	// Calculate the page size.
    CRect rect;
	GetClientRect(&rect);
	CSize pageSize(rect.right, rect.bottom);

	// Calculate the line size.
	CSize lineSize(0, logFont.lfHeight);

	// Adjust the scrollers.
	SetScrollSizes(MM_TEXT, docSize, pageSize, lineSize);

	// Restore the old font to the DC, and
	// delete the font the program created.
	pDC->SelectObject(oldFont);
	delete font;
}

void CMyScrollView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
// CMyScrollView diagnostics

#ifdef _DEBUG
void CMyScrollView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMyScrollView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CScrollDoc* CMyScrollView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CScrollDoc)));
	return (CScrollDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMyScrollView message handlers

void CMyScrollView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CScrollDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// Increase number of lines to display.
	pDoc->m_NumLines += 5;

	// Redraw the window.
	Invalidate();

	CScrollView::OnLButtonDown(nFlags, point);
}

void CMyScrollView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CScrollDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// Decrease number of lines to display.
	pDoc->m_NumLines -= 5;

	if (pDoc->m_NumLines < 0)
	{
		pDoc->m_NumLines = 0;
	}

	// Redraw the window.
	Invalidate();

	CScrollView::OnRButtonDown(nFlags, point);
}
