// File3View.cpp : implementation of the CFile3View class
//

#include "stdafx.h"
#include "File3.h"

#include "File3Doc.h"
#include "File3View.h"
#include "ChangeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFile3View

IMPLEMENT_DYNCREATE(CFile3View, CView)

BEGIN_MESSAGE_MAP(CFile3View, CView)
	//{{AFX_MSG_MAP(CFile3View)
	ON_COMMAND(ID_EDIT_CHANGEMESSAGE, OnEditChangemessage)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFile3View construction/destruction

CFile3View::CFile3View()
{
	// TODO: add construction code here

	m_message = "Default Message";
	m_fileLength = 0;
	m_filePath = "None";
}

CFile3View::~CFile3View()
{
}

BOOL CFile3View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CFile3View drawing

void CFile3View::OnDraw(CDC* pDC)
{
	CFile3Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	TEXTMETRIC tm;
	pDC->GetTextMetrics(&tm);
	int fontHeight = tm.tmHeight;

	pDC->TextOut(20, fontHeight, "CURRENT MESSAGE:");
	pDC->TextOut(40, fontHeight*2, m_message);
	pDC->TextOut(20, fontHeight*4, "FILE PATH:");
	pDC->TextOut(40, fontHeight*5, m_filePath);
	char s[20];
	wsprintf(s, "%d", m_fileLength);
	pDC->TextOut(20, fontHeight*7, "FILE LENGTH:");
	pDC->TextOut(40, fontHeight*8, s);
}

/////////////////////////////////////////////////////////////////////////////
// CFile3View diagnostics

#ifdef _DEBUG
void CFile3View::AssertValid() const
{
	CView::AssertValid();
}

void CFile3View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFile3Doc* CFile3View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFile3Doc)));
	return (CFile3Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFile3View message handlers

void CFile3View::OnEditChangemessage() 
{
	// TODO: Add your command handler code here
	
    CChangeDlg dialog(this);
    dialog.m_message = m_message;

    int result = dialog.DoModal();

    if (result == IDOK)
    {
        m_message = dialog.m_message;
        Invalidate();
    }
}

void CFile3View::OnFileOpen() 
{
	// TODO: Add your command handler code here
	
    // Open the file.
    CFile file("TESTFILE.TXT", CFile::modeRead);

    // Read data from the file.
    char s[81];
    int bytesRead = file.Read(s, 80);
    s[bytesRead] = 0;
    m_message = s;

    // Get information about the file.
    m_filePath = file.GetFilePath();
    m_fileLength = file.GetLength();

    // Repaint the window.
    Invalidate();
}

void CFile3View::OnFileSave() 
{
	// TODO: Add your command handler code here
	
    // Create the file.
    CFile file("TESTFILE.TXT",
        CFile::modeCreate | CFile::modeWrite);

    // Write data to the file.
    int length = m_message.GetLength();
    file.Write((LPCTSTR)m_message, length);

    // Obtain information about the file.
    m_filePath = file.GetFilePath();
    m_fileLength = file.GetLength();

    // Repaint the window.
    Invalidate();
}
